freeslot("sfx_djump")
sfxinfo[sfx_djump].caption = "Double Jump"

-----------------------------------------

addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "pie")
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and not (player.powers[pw_super])
		   player.mo.state = S_PLAY_ROLL
		   S_StartSound(player.mo, sfx_djump)
	       P_SetObjectMomZ(player.mo, 14*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end
		if not (player.pflags & PF_THOKKED)
		and not (player.mo.state == S_PLAY_PAIN)
		and not (player.mo.state == S_PLAY_DEAD)
		and not (player.mo.state == S_PLAY_DRWN)
		and (player.powers[pw_super])
		   S_StartSound(player.mo, sfx_djump)
		   P_SetObjectMomZ(player.mo, 17*FRACUNIT)
		   player.pflags = $ & ~PF_JUMPED
		   player.pflags = $ & ~PF_SPINNING
		   player.pflags = $1|PF_THOKKED
		end
	end	
end)


addHook("PlayerCanDamage", function(player)
    if (player.mo.skin == "pie")
    and (player.mo.state == S_PLAY_ROLL)
        return true   
    end
end)


addHook("PlayerThink", function(player)
    if player.mo.skin == "pie"
	    and (player.cmd.buttons & BT_SPIN)
		and not (player.pflags & PF_STASIS)
		and not (player.pflags & PF_FULLSTASIS)
		and not (player.pflags & PF_STARTDASH)
		and not (player.pflags & PF_FINISHED)
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_STARTDASH)
		and not (player.xmomentum)
		and	player.playerstate ~= PST_DEAD
		and player.powers[pw_carry] == CR_NONE
		and not P_PlayerInPain(player) then
		player.normalspeed = 60*FRACUNIT
    else
		player.normalspeed = skins["pie"].normalspeed
    end	
end)


addHook("PlayerThink", function(player)	
	if (player.mo.skin == "pie")
	and (player.speed > 30*player.mo.scale)
	and (P_IsObjectOnGround(player.mo))
	and not (player.powers[pw_super])
		P_SpawnSkidDust(player, 20*FRACUNIT, sfx_none)
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "pie")
	and (player.speed >= 50*FRACUNIT)
	and (player.cmd.buttons & BT_SPIN)
	and not (player.powers[pw_super]) then
	    player.charflags = $1|SF_RUNONWATER
	    player.powers[pw_strong] = STR_DASH
		local afterimages = P_SpawnGhostMobj(player.mo)
		afterimages.colorized = true
		afterimages.color = SKINCOLOR_PEPPER
		afterimages.frame = $|FF_ADD
		afterimages.fuse = 5
		afterimages.blendmode = AST_TRANSLUCENT
		afterimages.renderflags = player.mo.renderflags
	end	
	if not (player.speed >= 50*FRACUNIT)
	and not (player.cmd.buttons & BT_SPIN)
	and not (player.powers[pw_super]) then
		player.powers[pw_strong] = $ & ~STR_DASH
		player.charflags = $1 & ~SF_RUNONWATER
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "pie")
	and (player.speed >= 50*FRACUNIT)
	and (player.cmd.buttons & BT_SPIN)
	and (player.powers[pw_super]) then
	    player.charflags = $1|SF_RUNONWATER
	    player.powers[pw_strong] = STR_DASH
		local afterimages = P_SpawnGhostMobj(player.mo)
		afterimages.colorized = true
		afterimages.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
		afterimages.frame = $|FF_ADD
		afterimages.fuse = 5
		afterimages.blendmode = AST_TRANSLUCENT
		afterimages.renderflags = player.mo.renderflags
	end	
	if not (player.speed >= 50*FRACUNIT)
	and not (player.cmd.buttons & BT_SPIN)
	and (player.powers[pw_super]) then
		player.powers[pw_strong] = $ & ~STR_DASH
		player.charflags = $1 & ~SF_RUNONWATER
	end
end)


freeslot(
"SKINCOLOR_HYPER1",
"SKINCOLOR_HYPER2",
"SKINCOLOR_HYPER3",
"SKINCOLOR_HYPER4",
"SKINCOLOR_HYPER5",
"SKINCOLOR_HYPER6",
"SKINCOLOR_HYPER7")

// Red Starts

skincolors[SKINCOLOR_HYPER1] = {
	name = "Hyper 1",
	ramp = {0,0,0,0,0,0,0,0,209,209,210,210,32,32,33,33},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Blue

skincolors[SKINCOLOR_HYPER2] = {
	name = "Hyper 2",
	ramp = {0,0,0,0,0,0,0,0,129,129,130,130,131,131,132,132},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Green

skincolors[SKINCOLOR_HYPER3] = {
	name = "Hyper 3",
	ramp = {0,0,0,0,0,0,0,0,98,98,99,99,100,100,101,101},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Yellow

skincolors[SKINCOLOR_HYPER4] = {
	name = "Hyper 4",
	ramp = {0,0,0,0,0,0,0,0,82,82,83,83,72,72,74,74},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// White

skincolors[SKINCOLOR_HYPER5] = {
	name = "Hyper 5",
	ramp = {0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Violet

skincolors[SKINCOLOR_HYPER6] = {
	name = "Hyper 6",
	ramp = {0,0,0,0,0,0,0,0,160,160,161,161,162,162,163,163},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Red ending

skincolors[SKINCOLOR_HYPER7] = {
	name = "Hyper 7",
	ramp = {0,0,0,0,0,0,0,0,200,200,201,201,202,202,203,203},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}